var Animatable = {
  xpos: null,
  ypos: null,
  scale: null,
  scaleX: null,
  scaleY: null
};

var _old_animate = jQuery.fn.animate;

jQuery.fn.extend({
  animate: function( prop, speed, easing, callback ) {
    // Carryover stuff from jQuery.fn.animate
    var optall = jQuery.speed(speed, easing, callback);
    
    this[ optall.queue === true ? "queue" : "each" ](function() {
      $.extend(this, Animatable);
      // if(this.id == "counterattack"){ console.log("["+prop.xpos+","+prop.ypos+"]"); console.log(prop)}
      if (prop.xpos !== undefined ) this.xpos = $(this).position().left;
      if (prop.ypos !== undefined ) this.ypos = $(this).position().top;
      if (prop.scale !== undefined ) {
        this.scale = 1.0;
        if($(this).css('-webkit-transform') !== "none")
          this.scale = getScaleFromMatrix($(this).css('-webkit-transform'));
      }
      
      // if (prop.scaleX !== null ) {
      //   this.scaleX = this.scale;
      //   if($(this).css('-webkit-transform') !== "none") {
      //     var matrix_values = parseMatrixTransformCSS($(this).css('-webkit-transform'));
      //     this.scaleX = parseFloat(matrix_values.scaleX);
      //   }
      // }
      // 
      // if (prop.scaleY !== null ) {
      //   this.scaleY = this.scale;
      //   if($(this).css('-webkit-transform') !== "none") {
      //     var matrix_values = parseMatrixTransformCSS($(this).css('-webkit-transform'));
      //     this.scaleY = parseFloat(matrix_values.scaleY);
      //   }
      // }
      
      
        
    });
    
    return _old_animate.apply( this, arguments );
  }
})

var originalStep = $.fx.step._default;
$.fx.step._default = function(fx) {
  if (!fx.elem.fastAnimate) return originalStep(fx);
  // Animation caching
  // if (!fx.elem.cachedValues[fx.prop]) fx.elem.cachedValues[fx.prop] = [];
  // fx.elem.cachedValues[fx.prop].push(fx.elem[fx.prop]);
  
  // These are required for jQuery animations to run properly
  fx.elem[fx.prop] = fx.now;
  fx.elem.updated = true;
  
  var transform = "";
  var matrix_values = parseMatrixTransformCSS($(fx.elem).css('-webkit-transform'));
  if(fx.elem.xpos !== null || fx.elem.ypos !== null || matrix_values.x > 0 || matrix_values.y > 0) {
    var xpos = parseInt(fx.elem.xpos || matrix_values.x || 0);
    var ypos = parseInt(fx.elem.ypos || matrix_values.y || 0)
    transform += ' translate3d('+ xpos +'px,'+ypos+'px,0) ';
  }
  if(fx.elem.scale) transform += ' scale('+fx.elem.scale+') ';
  if(fx.elem.scaleX) transform += ' scaleX('+fx.elem.scaleX+') ';
  if(fx.elem.scaleY) transform += ' scaleY('+fx.elem.scaleY+') ';
  
  var css_transform = {'-webkit-transform':transform};
  
  if (fx.elem.xpos !== null || fx.elem.ypos !== null) $.extend(css_transform, {left:'0', top:'0'});
  
  $(fx.elem).css( css_transform );
  
  
};

var AnimTracker = {
  last_time: null,
  cur_time: null,
  times: [],
  timeout: null,
  interval: null,
  start: function() {
    this.interval = setInterval(function() {
      if (AnimTracker.last_time == null) {
        AnimTracker.last_time = Date.now();
        return;
      }
      AnimTracker.cur_time = Date.now();
      AnimTracker.times.push(Math.round(1000.0 / (AnimTracker.cur_time-AnimTracker.last_time)));
      AnimTracker.last_time = AnimTracker.cur_time;
      
    }, $.fx.interval);
  },
  finish: function() {
    clearInterval(this.interval);
    mpmetrics.track('speed_data', {'avg': average(this.times), 'stddev': num_with_precision( std_dev(this.times), 1)});
    console.log('speed_data'+ JSON.stringify({'avg': average(this.times), 'stddev': num_with_precision( std_dev(this.times), 1)}));
    this.times = [];
  }
}
