var Concerns = {};
function Concern( options ) {
  $.extend(this, options);
  this.icon = "i/concerns/"+options.name + ".png";
  Concerns[options.name] = this;
}

new Concern( {  
  name:"sad",
  priority:50,  
  test:function( monster ) { return false; /* (monster.is_sad || current_timestamp() - monster.last_sad > 60*60*24*2);*/ },
  respond:function(monster){
    generate_homescreen_doobers(3, monster);
    monster.last_sad = current_timestamp();
    monster.is_sad = false;
    home.animate_happy_jump(monster);
  }
});

new Concern( {  
  name:"hungry",
  priority:25,
  test:function( monster ) { return false; /*(current_timestamp() - monster.last_hungry > 60*60*6  6 hours  );*/ },
  respond:function( monster ){ 
    FX.doober(); 
    generate_homescreen_doobers(3, monster);
    monster.last_hungry = current_timestamp();
    home.animate_happy_jump(monster);
  }
});

new Concern( {  
  name:"leveled",
  priority:100,  
  test:function( monster ) { return false; /*(monster.pending_level_ups.length > 0);*/ },
  respond:function( monster ){
    generate_homescreen_doobers(6, monster);
    monster.grant_level_up(); 
    $(monster.avatar_id + ' .level_up').show()
      .animate({'font-size':'35px'}, 300)
      .animate({'font-size':'20px', opacity:0.0}, 1000, function() {  
        $('.level_up').hide().css({'font-size': '20px', 'opacity':1.0}) 
      });
    home.show(); 
    }
});
